from cpl_core.logging import LoggerABC
from cpl_discord.events import OnReadyABC
from cpl_discord.service import DiscordBotServiceABC

from bot_core.logging.task_logger import TaskLogger
from modules.special_offers.base.special_offer_watcher_abc import SpecialOfferWatcherABC


class SpecialOfferOnReadyEvent(OnReadyABC):
    def __init__(
        self,
        logger: TaskLogger,
        bot: DiscordBotServiceABC,
        watchers: list[SpecialOfferWatcherABC],
    ):
        OnReadyABC.__init__(self)

        self._logger = logger
        self._bot = bot
        self._watchers = watchers

    async def on_ready(self):
        for watcher in self._watchers:
            self._logger.info(__name__, f"Starting watcher {type(watcher).__name__}")
            watcher.start()
